//https://bitabittecnologia.com.br

//https://www.youtube.com/bitabit

//Link para o vídeo:
//https://youtu.be/yktnhH69-K8

#include <Wire.h>
#include <TimeLib.h>
#include <DS1307RTC.h>

#define BUZZER_MAX_VOLUME 150
#define BUZZER_MIN_VOLUME 0
#define BUZZER_PIN 3
#define PARAR_ALARME 2

//Quantidade dos alarmes
#define QTD_ALARMES(horarios)  (sizeof(horarios) / sizeof((horarios)[0]))

//Definições dos alarmes
#define ALARMES "17:20:00", "17:26:00"

tmElements_t tm;

int hora, minuto, segundo;
bool executar = false;

unsigned long intervaloAlarme = 0;
bool estadoAlarme = true;

char *despertar[]{ALARMES};

void executarAlarme()
{
  if(estadoAlarme)
  {
    analogWrite(BUZZER_PIN, BUZZER_MAX_VOLUME);
  }
  else
  {
    analogWrite(BUZZER_PIN, BUZZER_MIN_VOLUME);
  }

  estadoAlarme = !estadoAlarme;
}

void setup() 
{
  pinMode(PARAR_ALARME, INPUT_PULLUP);
}

void loop() 
{
  //Checa as definições dos alarmes com o horário atual
  for(int i=0; i<QTD_ALARMES(despertar); i++)
  {
    if(RTC.read(tm))
    {
      sscanf(despertar[i], "%d:%d:%d", &hora, &minuto, &segundo);

      if(hora == tm.Hour && minuto == tm.Minute && segundo == tm.Second)
      {
        executar = true;
      }
    }
  }

  if(executar)
  {
    if(millis() - intervaloAlarme > 500)
    {
      executarAlarme();
      intervaloAlarme = millis();
    }
  }

  if(!digitalRead(PARAR_ALARME))
  {
      executar = false;
      analogWrite(BUZZER_PIN, BUZZER_MIN_VOLUME);
  }
}
